aboutsummaryrefslogtreecommitdiff
path: root/net.Linux/ip6to4.sh
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2007-04-05 11:18:42 +0000
committerRoy Marples <roy@marples.name>2007-04-05 11:18:42 +0000
commit5af58b45146ab5253ca964738f4e45287bf963d4 (patch)
tree68d3a9a61fa55dd7fe273db776c375f797edaa5b /net.Linux/ip6to4.sh
Rewrite the core parts in C. We now provide librc so other programs can
query runlevels, services and state without using bash. We also provide libeinfo so other programs can easily use our informational functions. As such, we have dropped the requirement of using bash as the init script shell. We now use /bin/sh and have strived to make the scripts as portable as possible. Shells that work are bash and dash. busybox works provided you disable s-s-d. If you have WIPE_TMP set to yes in conf.d/bootmisc you should disable find too. zsh and ksh do not work at this time. Networking support is currently being re-vamped also as it was heavily bash array based. As such, a new config format is available like so config_eth0="1.2.3.4/24 5.6.7.8/16" or like so config_eth0="'1.2.3.4 netmask 255.255.255.0' '5.6.7.8 netmask 255.255.0.0'" We will still support the old bash array format provided that /bin/sh IS a link it bash. ChangeLog for baselayout-1 can be found in our SVN repo.
Diffstat (limited to 'net.Linux/ip6to4.sh')
-rw-r--r--net.Linux/ip6to4.sh97
1 files changed, 97 insertions, 0 deletions
diff --git a/net.Linux/ip6to4.sh b/net.Linux/ip6to4.sh
new file mode 100644
index 00000000..03d4fac3
--- /dev/null
+++ b/net.Linux/ip6to4.sh
@@ -0,0 +1,97 @@
+# Copyright 2004-2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+_config_vars="$_config_vars link suffix relay"
+
+ip6to4_depend() {
+ after interface
+}
+
+ip6to4_start() {
+ case " ${MODULES} " in
+ *" ifconfig "*)
+ if [ "${IFACE}" != "sit0" ] ; then
+ eerror "ip6to4 can only work on the sit0 interface using ifconfig"
+ eerror "emerge sys-apps/iproute2 to use other interfaces"
+ return 1
+ fi
+ esac
+
+ local host= suffix= relay= addr= iface=${IFACE} new=
+ eval host=\$link_${IFVAR}
+ if [ -z "${host}" ] ; then
+ eerror "link_${IFVAR} not set"
+ return 1
+ fi
+
+ eval suffix=\${suffix_${IFVAR}:-1}
+ eval relay=\${relay_${IFVAR}:-192.88.99.1}
+
+ IFACE=${host}
+ addrs=$(_get_inet_addresses)
+ IFACE=${iface}
+ if [ -z "${addrs}" ] ; then
+ eerror "${host} is not configured with an IPv4 address"
+ return 1
+ fi
+
+ for addr in ${addrs} ; do
+ # Strip the subnet
+ local ip="${addr%/*}" subnet="${addr#*/}"
+ # We don't work on private IPv4 addresses
+ case "${ip}" in
+ 127.*) continue ;;
+ 10.*) continue ;;
+ 192.168.*) continue ;;
+ 172.*)
+ local i=16
+ while [ ${i} -lt 32 ] ; do
+ case "${ip}" in
+ 172.${i}.*) break ;;
+ esac
+ i=$((${i} + 1))
+ done
+ [ ${i} -lt 32 ] && continue
+ ;;
+ esac
+
+ veinfo "IPv4 address on ${host}: ${ip}/${subnet}"
+ local OIFS=$IFS SIFS=${IFS-y} ipa= ip6=
+ IFS="${IFS}."
+ for i in ${ip} ; do
+ ipa="${ipa} ${i}"
+ done
+ if [ "${SIFS}" = "y" ] ; then
+ IFS=$OIFS
+ else
+ unset IFS
+ fi
+ eval ip6="$(printf "2002:%02x%02x:%02x%02x::%s" ${ipa} ${suffix})"
+ veinfo "Derived IPv6 address: ${ip6}"
+
+ # Now apply our IPv6 address to our config
+ new="${new}${new:+ }${ip6}/16"
+ done
+
+ if [ -z "${new}" ] ; then
+ eerror "No global IPv4 addresses found on interface ${host}"
+ return 1
+ fi
+
+ if [ "${IFACE}" != "sit0" ] ; then
+ ebegin "Creating 6to4 tunnel on ${IFACE}"
+ _tunnel add "${IFACE}" mode sit ttl 255 remote any local "${ip}"
+ eend $? || return 1
+ _up
+ fi
+
+ # Now apply our config
+ eval config_${config_index}=\'"${new}"\'
+ config_index=$((${config_index} - 1))
+
+ # Add a route for us, ensuring we don't delete anything else
+ eval $(_get_array "routes_${IFVAR}")
+ eval routes_${IFVAR}="\"$@ '2003::/3 via ::${relay} metric 2147483647'\""
+}
+
+# vim: set ts=4 :